; *************************    OEd Menu Layout:    *************************
;
; There be an arbitrary number of menu strips. Each must be introduced
; by an statement of the form
;
;   MENU <name>
;
; The following lines specify the menu's items. An item may be a seperator
; line or a selectable menu item. Seperator lines are defined by
;
;   SEPARATOR
;
; Selectable items are created with a statement like
;
;   ITEM <name> <command>
;
; where <name> is the name of the item and <command> is an OEd command
; specifying the action a selection of the item should cause.
;
; Subitems are currently not supported.
;
; Menu Shortcuts are not defined here. The file Oberon:OEd_Keys.txt is used
; for this.
;
; IMPORTANT NOTES:
;
;   OEd does not check if your menu fits on the screen. So if one of your
;   menus is too big and you're not using AmigaOS 2.0 your machine may
;   crash.
;
;   The lines of this text mustn't be longer that 256 characters.
;

MENU "Projekt"

ITEM      "Laden..."                  (load)
ITEM      "Neues Fenster..."          (newwindow)
ITEM      "Speichern"                 (save)
ITEM      "Speichern unter..."        (saveas)
ITEM      "Block speichern..."        (bsave)
ITEM      "Datei einfgen..."         (insfile)
SEPARATOR
ITEM      "Drucken"                   (print)
ITEM      "Block drucken"             (printblock)
ITEM      "Drucken als..."            (printas)
ITEM      "Block drucken als..."      (printblkas)
SEPARATOR
ITEM      "Verstecken"                (hide)
ITEM      "Anzeigen..."               (reveal)
SEPARATOR
ITEM      "Bildschirmmodus..."        (screenmode)
SEPARATOR
ITEM      "ber..."                   (about)
ITEM      "Ende"                      (quit)


MENU "Suchen"

ITEM      "Suchen..."                 (find)
ITEM      "Nchstes"                  (next)
ITEM      "Voriges"                   (prev)
SEPARATOR
ITEM      "Suchen-Ersetzen..."        (findrep)
ITEM      "Nchstes ersetzen"         (nextrep)
ITEM      "Voriges ersetzen"          (prevrep)
SEPARATOR
ITEM      "Wort suchen"               (execrexx (options results; getword; findstr result; next))
SEPARATOR
ITEM      "Gro/Klein unterscheiden"  (casesens)
ITEM      "Wortweise"                 (wordbyword)


MENU "Block"

ITEM      "Anfang"                    (bbegin)
ITEM      "Ende"                      (bend)
ITEM      "Alles markieren"           (markall)
ITEM      "Kopieren"                  (bcopy)
ITEM      "Verschieben"               (bmove)
ITEM      "Lschen"                   (bdelete)
SEPARATOR
ITEM      "Schneiden"                 (cut)
ITEM      "Kopieren"                  (copy)
ITEM      "Einfgen"                  (paste)
SEPARATOR
ITEM      "Tabulator rechts"          (btabright)
ITEM      "Tabulator links"           (btableft)
SEPARATOR
ITEM      "Markierung lschen"        (bunmark)


MENU "Spezial"

ITEM      "Rexx-Kommando eingeben..." (enterrexx)
ITEM      "Rexx-Kommando ausfhren"   (execrexx)
ITEM      "Rexx unterbrechen (HI)"    (stoprexx)
SEPARATOR
ITEM      "An Zeile springen..."      (gotoy)
ITEM      "Zur letzten nderung"      (gotolastch)
SEPARATOR
ITEM      "Passende Klammer"          (mbracket)
ITEM      "Gro/Klein wechseln"       (changecase)
SEPARATOR
ITEM      "Undo"                      (undo)
ITEM      "Redo"                      (redo)
ITEM      "Undo All"                  (undoall)
ITEM      "Redo All"                  (redoall)
ITEM      "Undos freigeben"           (clearundos)
SEPARATOR
ITEM      "Gelschte Zeile einfgen"  (undeline)


MENU "Makros"

ITEM      "Lernen anfangen"           (startmacro (t:RexxMacro_F10.oed))
ITEM      "Lernen beenden"            (stopmacro)
ITEM      "Abspielen"                 (rx (t:RexxMacro_F10.oed))


MENU "Oberon"

ITEM      "Parsen"                    (parse)
ITEM      "Compilieren..."            (compile)
ITEM      "Linken..."                 (link)
ITEM      "Machen..."                 (make)
ITEM      "Ausfhren..."              (execute)
SEPARATOR
ITEM      "Compiler Optionen..."      (coptions)
SEPARATOR
ITEM      "Nchster Fehler"           (nexterror)
ITEM      "Erster Fehler"             (firsterror)
ITEM      "Fehlerdatei neu laden"     (reloaderrs)


MENU "Optionen"

ITEM      "StackChk"                  (stackchk)
ITEM      "OvflChk"                   (ovflchk)
ITEM      "RangeChk"                  (rangechk)
ITEM      "CaseChk"                   (casechk)
ITEM      "ReturnChk"                 (returnchk)
ITEM      "NilChk"                    (nilchk)
ITEM      "TypeChk"                   (typechk)
ITEM      "OddChk"                    (oddchk)
ITEM      "AutRegPars"                (autoregpars)
ITEM      "Clear Vars"                (clearvars)
ITEM      "New Symbolfile"            (newsymfile)
SEPARATOR
ITEM      "SmallCode"                 (smallcode)
ITEM      "SmallData"                 (smalldata)
ITEM      "Garbage-Collector"         (garbagecollector)
ITEM      "Language Extensions"       (extensions)
SEPARATOR
ITEM      "Debug"                     (debug)
SEPARATOR
ITEM      "68010"                     (mc68010)
ITEM      "68020"                     (mc68020)
ITEM      "68030"                     (mc68030)
ITEM      "68881/68882"               (mc68881)


MENU "Einstellungen"

ITEM      "Einfgen"                  (insert)
ITEM      "Layout Modus"              (layout)
ITEM      "Autom. Groschreibung"     (autouc)
SEPARATOR
ITEM      "Piktogramme erzeugen?"     (icons)
ITEM      "Script-Flag setzen?"       (script)
SEPARATOR
ITEM      "Keine Umlaute"             (execrexx ('map ( (write ae))'; 'map ( (write oe))'; 'map ( (write ue))'; 'map ( (write Ae))'; 'map ( (write Oe))'; 'map ( (write Ue))'; 'map ( (write ss))'))
ITEM      "Umlaute"                   (execrexx ('map ( (write ))'; 'map ( (write ))'; 'map ( (write ))'; 'map ( (write ))'; 'map ( (write ))'; 'map ( (write ))'; 'map ( (write ))'))
SEPARATOR
ITEM      "Wordwrap an"               (map (SPACE (execrexx (options results; getposx; if result<77 then 'write " "'; else do; wleft; getposx; if result>1 then do; split; last; right; end; else 'return'; end))))
ITEM      "Wordwrap aus"              (map (SPACE (write " ")))

